<?php

namespace Teknisa\DF\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\ParameterBag;

class RegrafiscalAgrupimposto extends \Teknisa\DF\Controllers\TeknisaCrud
{
    protected $dataSourceName = 'regrafiscal_agrupimposto';
    protected $environment;
    protected $entityManager;
    protected $parameterBagColumns = array(
        'P_CDFILIAL'
    );
    
    public function __construct($crudService, ParameterBag $parameterBag, $environment, $entityManager) {
        parent::__construct($crudService, $parameterBag);
        $this->environment      = $environment;
        $this->entityManager    = $entityManager;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        $regraFiscalPorEmpresa = $this->visualizaRegraEmpresa();
        
        if($regraFiscalPorEmpresa) {
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->addCondition('P_CDFILIAL', $this->environment->getCdFilial());

            $this->dataSourceName = 'regrafiscal_agrupimposto_empresa';
        }
        else {
            $this->dataSourceName = 'regrafiscal_agrupimposto';   
        }
        
        parent::find($request, $response);
    }
    
    private function visualizaRegraEmpresa() {
        $sql = "SELECT IDVISUREGFISEMPR FROM PARAMGERAL";
       
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute();

        $paramGeral = $std->fetchAll();
        
        if(isset($paramGeral[0])) {
            if($paramGeral[0]["IDVISUREGFISEMPR"] == "S") return true;
            
            return false;
        }
        
        return false;
        
    }
}