<?php

namespace Teknisa\DF\Factories;

use Doctrine\ORM\EntityManager;

class RelacionamentoProdXSystaxFactory {
    
    private $entityManager;
    
    public function __construct(EntityManager $entityManager, $environment)
    {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
    }

    public function findOrigem(){
        $sql = "select
                    DISTINCT ORIGEM 
                from 
                    sys_cenario";
            
        return $this->entityManager->getConnection()->fetchAll($sql);
    }
    
    public function updataTIPOITEMPROD($CDTPITEMPROD, $NMTPITEMPROD, $CDORIGEMSYSTAX, $DSORIGEMSYSTAX){
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        $sql = "    UPDATE 
                        TIPOITEMPROD 
                    SET 
                        CDORIGEMSYSTAX = :CDORIGEMSYSTAX,
                        DSORIGEMSYSTAX = :DSORIGEMSYSTAX
                    
                    WHERE  
                        CDTPITEMPROD = :CDTPITEMPROD";
        $params = array(
            "CDTPITEMPROD"   => $CDTPITEMPROD,
            "CDORIGEMSYSTAX" => $CDORIGEMSYSTAX,
            "DSORIGEMSYSTAX" => $DSORIGEMSYSTAX
        );
            
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std        ->execute($params);
        $connection ->commit();
    }
}